#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <unistd.h>
#include <signal.h>
#include <string.h>

#define MAXLINE 512
char serv_ip[20];
char command[132];

int
  readn (int fd, char *ptr, int nbytes);
int
  writen (int fd, char *ptr, int nbytes);
int
  readline (int fd, char *ptr, int maxlen);
void
  schedula (void);

int
main (int argc, char *argv[])
{
  struct in_addr *ptr;
  struct hostent *host;
  char *com;


  if (argc != 3) {
    printf ("chiamata %s hostname directory-html\n", argv[0]);
    exit (1);
  }

  com = command;

  host = gethostbyname (argv[1]);
  ptr = (struct in_addr *) *host->h_addr_list;
  strcpy (serv_ip, inet_ntoa (*ptr));

  strcpy (com, "GET ");
  strcat (com, argv[2]);
  strcat (com, "\n");

  schedula ();
  while (1) {
    alarm (30);
    pause ();
  }
}

/* read "n" bytes from a stream socket */

int
readn (fd, ptr, nbytes)
     register int fd;
     register char *ptr;
     register int nbytes;
{
  int nleft, nread;

  nleft = nbytes;
  while (nleft > 0) {
    nread = read (fd, ptr, nleft);
    if (nread < 0)
      return (nread);		/* error */
    else if (nread == 0)
      break;			/* EOF */
    nleft -= nread;
    ptr += nread;
  }
  return (nbytes - nleft);
}


/* write "n" bytes to a stream socket */

int
writen (fd, ptr, nbytes)
     register int fd;
     register char *ptr;
     register int nbytes;
{
  int nleft, nwritten;

  nleft = nbytes;
  while (nleft > 0) {
    nwritten = write (fd, ptr, nleft);
    if (nwritten < 0)
      return (nwritten);	/* error */
    else if (nwritten == 0)
      break;			/* EOF */
    nleft -= nwritten;
    ptr += nwritten;
  }
  return (nbytes - nleft);
}


/* read a line from a stream socket */

int
readline (fd, ptr, maxlen)
     register int fd;
     register char *ptr;
     register int maxlen;
{
  int n, rc;
  char c;

  for (n = 1; n < maxlen; n++) {
    if ((rc = read (fd, &c, 1)) == 1) {
      *ptr++ = c;
      if (c == '\n')
	break;
    }
    else if (rc == 0) {
      if (n == 1)
	return (0);		/* EOF */
      else
	break;
    }
    else
      return (-1);		/* error */
  }
  *ptr = 0;
  return (n);
}

void
schedula (void)
{
  char buffer[1024];
  struct sockaddr_in serv_sock;
  int n, s;

  signal (SIGALRM, schedula);

  bzero ((char *) (&serv_sock), sizeof (serv_sock));
  serv_sock.sin_family = AF_INET;
  serv_sock.sin_port = htons (80);
  serv_sock.sin_addr.s_addr = inet_addr (serv_ip);

  if ((s = socket (AF_INET, SOCK_STREAM, 0)) < 0)
    perror ("socket: ");
  if (connect (s, (struct sockaddr *) &serv_sock, sizeof (serv_sock)) < 0)
    perror ("connect: ");
  if (write (s, command, strlen (command)) != strlen (command))
    perror ("write: ");

  for (;;) {
    n = readline (s, buffer, MAXLINE);
    if (n == 0) {
      close (s);
      return;
    }				/* connection terminated */
    else if (n < 0)
      perror ("readline error");
    if (writen (1, buffer, n) != n)
      perror ("writen error");
  }
}
