/* */

/* tree -> array dichiarato nel programma fortran di dimensione DIM [0..DIM] */

#define DIM   100
#define V     0   /* Value           */
#define R     1   /* Right           */
#define L     2   /* Left            */
#define RED   3
#define HEAD  3
#define Z     0
#define TRUE  1
#define FALSE 0

int rotate (tree,v,y)

int v, y;
short int tree[DIM+1][4];

{
   int s, gs;

   if (v < tree[y][V])
      s = tree[y][L];
   else
      s = tree[y][R];

   if (v < tree[s][V])
   {
      gs = tree[s][L];
      tree[s][L] = tree[gs][R];
      tree[gs][R] = s;
   }
   else
   {
      gs = tree[s][R];
      tree[s][R] = tree[gs][L];
      tree[gs][L] = s;
   }

   if (v < tree[y][V])
      tree[y][L] = gs;
   else
      tree[y][R] = gs;

   return (gs);
}


int split (tree,v,gg,g,f,x)

int v, gg, g, f, x;   /* Qui v arriva da una chiamata C (non serve *v) */
short int tree[DIM+1][4];

{
   int left, right;

   tree[x][RED] = TRUE;
   left  = tree[x][L];
   right = tree[x][R];
   tree[left][RED]  = FALSE;
   tree[right][RED] = FALSE;

   if (tree[f][RED])
   {
      tree[g][RED] = TRUE;
      if ((v < tree[g][V]) != (v < tree[f][V])) f = rotate(tree,v,g);
      x = rotate(tree,v,gg);
      tree[x][RED] = FALSE;
   }
   right = tree[HEAD][R];
   tree[right][RED] = FALSE;
   return (x);
}



/**********************************************************/
/* Procedura per l'inserimento di un elemento nell'albero */
/**********************************************************/

void rbtreeinsert_(tree,v,p,out)  /* v    -> Valore da inserire
                                     tree -> Indirizzo primo elemento di tree
                                     p    -> Posizione libera */

short int   tree[DIM+1][4],  /* Vengono usati gli elementi da HEAD a DIM */
            *out;
int   *v, *p;

/* Deve essere *v perche' la chiamata fortran passa gli indirizzi */

{
   int gg, g, f, x, left, right;

   x = HEAD;
   f = x;
   g = x;

   do
   {
      gg = g;
      g = f;
      f = x;
      if (*v == tree[x][V])
      {
         *out = 1;
         return;
      }
      if (*v < tree[x][V])
         x = tree[x][L];
      else
         x = tree[x][R];

      left  = tree[x][L];
      right = tree[x][R];
      if (tree[left][RED] && tree[right][RED]) x = split(tree,*v,gg,g,f,x);
    } while (x != Z);

/* Considera un nuovo elemento */

    x = *p;
    tree[x][V] = *v;
    tree[x][L] = Z;
    tree[x][R] = Z;

    if (f != x)
    {
       if (*v < tree[f][V])
          tree[f][L] = x;
       else
          tree[f][R] = x;

       x = split (tree,*v,gg,g,f,x);
    }
    *out = 0;
}


void rbtreesearch_(tree,v,out)

short int   tree[DIM+1][4], *out;
int   *v;

{
   int x;

   x = HEAD;
   do
   {
      if (*v == tree[x][V]) break;

      if (*v < tree[x][V])
         x = tree[x][L];
      else
         x = tree[x][R];

    } while (x != Z);

    *out = x;
}


void rbtreeinit_(tree)

short int   tree[DIM+1][4];

{
   int i;

   for (i=0; i<=DIM; i++)
   {
      tree[i][V] = 0;
      tree[i][R] = Z;
      tree[i][L] = Z;
      tree[i][RED] = FALSE;
   }
}
