/* socket TCP  server */

#include "inet.h"
main (argc, argv)
int   argc;
char *argv[];
{
  int   sockfd,
        newsockfd,
        clilen,
        childpid;
  struct sockaddr_in  cli_addr,
                      serv_addr;
  char *inet_ntoa(); 	/*pointer to a dot notation */
  char client_name[50], *p = client_name;
  struct hostent *client_info, *gethostbyaddr();

  pname = argv[0];

  if ((sockfd = socket (AF_INET, SOCK_STREAM, 0)) < 0)
    err_dump ("server: can't open stream socket");

  bzero ((char *) &serv_addr, sizeof (serv_addr));
  serv_addr.sin_family = AF_INET;
  serv_addr.sin_addr.s_addr = htonl (INADDR_ANY);
  serv_addr.sin_port = htons (SERV_TCP_PORT);

  if (bind (sockfd, (struct sockaddr *) &serv_addr, sizeof (serv_addr)) < 0)
    err_dump ("can't bind local address");

  listen (sockfd, 5);

  for (;;) {
    clilen = sizeof (cli_addr);
    newsockfd = accept (sockfd, (struct sockaddr *) &cli_addr, &clilen);
    if (newsockfd < 0)
      err_dump ("server: accept error");

    if ((childpid = fork ()) < 0)
      err_dump ("server: fork error");
    else
      if (childpid == 0) {	/* child process */
	close (sockfd);

        if((client_info = gethostbyaddr((char *)&cli_addr.sin_addr,
            sizeof(struct in_addr), cli_addr.sin_family)) == NULL) {
          (void) strcpy(client_name, "Unknown host");
          (void) strcat(client_name, " ");
          (void) strcat(client_name, inet_ntoa(cli_addr.sin_addr));
          }
        else
          p = client_info->h_name;
        printf(" client process on host %s connected to server\n", p);

	str_echo (newsockfd); 
	exit (0);
      }
    close (newsockfd);		/* parent process */
  }
}
