#include <stdio.h>

#define TRUE		1
#define FALSE		0
#define repeat		for(;;)
#define until(A)	if(A) break;

#define FIND  0
#define ENTER 1

typedef int    *TABELEM;	/* What the table contains (TABle ELEMents) */
static TABELEM *table;		/* The address of the hash table */
static unsigned int count = 0;	/* Number of entries in hash table */

static unsigned int length;	/* Size of the hash table */
static unsigned int prcnt;	/* Number of probes this item */

typedef char   *POINTER;

int            *base_matk;

extern void     free();
extern int      printf();
extern char    *calloc();

short int       hcreate_();
void            hdestroy_();
short int       hsearch_();

short int
hcreate_(size, matk_base)	/* Create a hash table no smaller than size */
  short int      *size;		/* Minimum size for hash table */
  int            *matk_base;
{
  short int       ii;

  base_matk = matk_base;

  length = *size;
  if (length <= 0)
    return (FALSE);

  table = (TABELEM *) calloc(length, sizeof(TABELEM));
  ii = (table != NULL);
  return *((short int *) &ii);
}

void
hdestroy_()
{				/* Reset the module to its initial state */
  if (table != NULL)
    free((POINTER) table);
  count = 0;
}

/*
 * Hash search of a fixed-capacity table.  
 * Open addressing used to resolve collisions.  
 * Rehashing con i = k +- prcnt^2 
 */

short int
hsearch_(item, action)		/* Find or insert the item into the table */
  int            *item;		/* Item to be inserted or found */
  short int      *action;	/* FIND or ENTER */
{
  unsigned int    k;		/* Insertion index */
  unsigned int    i;		/* Running insertion index */
  unsigned int    c;		/* Secondary probe displacement */
  short int       ii;
  int             matk_offset;
  short int       piuomeno;

  piuomeno = 0;
  prcnt = 1;

  k = *item % length;		/* Primary hash on key */
  i = k;
  if (table[i] == NULL)		/* Empty slot? */
    goto D6;
  else if (*table[i] == *item) {/* Match? */
    ii = (short int) ((table[i] - base_matk) + 1);
    return *((short int *) &ii);
  }
D4:c = (piuomeno) ? prcnt : prcnt + length;	/* No match => compute
						 * secondary hash */
  piuomeno = ~piuomeno;
  i = (k + c) % length;		/* Advance to next slot */

  prcnt++;
  if (table[i] == NULL)		/* Empty slot? */
    goto D6;
  else if (*table[i] == *item) {/* Match? */
    /* printf("The number of probes required was %d\n", prcnt); */
    ii = (short int) ((table[i] - base_matk) + 1);
    return *((short int *) &ii);
  } else
    goto D4;

D6:if (*action == FIND) {	/* Insert if requested */
    ii = NULL;
    return *((short int *) &ii);
  }
  if (count == (length - 1)) {	/* Table full? */
    ii = -1;
    return *((short int *) &ii);
  }
  count++;			/* Increment table occupancy count */
  table[i] = item;		/* Copy key pointer in table[i]	 */
  /* printf("The number of probes required was %d\n", prcnt);	 */
  ii = (short int) ((table[i] - base_matk) + 1);
  return *((short int *) &ii);
}
