#include<stdio.h>
#include<unistd.h>
#include<signal.h>
#include<stdlib.h>

#define K 2 

void dovevado(int sig);
void vadovia(int sig);
void partenza(int sig);
void arrivo(int sig);
void treno(int ntren);
void niente(int sig);

int LU[4],LE[10];
int fdarrivi[2],fdpartenze[2];
int pidt[10];
char buf[]="\0\0\0\0\0\0\0\0\0\0\0";
int lu;

int numerotreno; /* Treno corrente */



main()
{ int i;

 setbuf(stdout,0);
 pipe(fdarrivi);
 pipe(fdpartenze);

 signal(SIGUSR1,arrivo);
 signal(SIGUSR2,partenza);
 
 signal(SIGALRM,niente);
 
 for(i=0;i<10;i++) {
      pidt[i]=fork();
      if(pidt[i]==0) {
            treno(i);
            return 0;
      }
 }

/*--------Stazione---------*/


 
close(fdarrivi[1]); /* La stazione legge */
close(fdpartenze[1]);
printf("Stazione pronta\n");

while(1) {
    i=0;
    while(1) {
			   if(LE[i]==1) break;
			   i=(i+1) % 10;
	           sleep(1);
	           printf("Binario %d vuoto\n",i-1);		   
	}
	
    printf("Il treno %d puo\' entrare in stazione\n",i);	
	kill(SIGUSR1,pidt[i]); /* Dice al treno di comunicare dove vuole andare */
	read(fdarrivi[0],buf,1);
	sscanf(buf,"%d",&lu);
	if(LU[lu]==0) {
			kill(SIGUSR2,pidt[i]);  /* Si puoi entrare */
			LU[lu]=1; /* Occupa il binario di uscita */
	}		
	
    	
}   
    
    	
}    	
	

	
void partenza(int sig)  /* Stabilisce quale treno va via */
{
 int binario;
 char buf[]="\0"; 
 signal(SIGUSR2,partenza);		
 read(fdpartenze[0],buf,(size_t) 1);
 sscanf(buf,"%d",&binario);
 LU[binario]=0;
 printf("Partenza al binario %d\n",binario);
} 
 
void arrivo(int sig) /* Stabilisce quale treno arriva */
{
 int numtreno;
 char buf[]="\0";
		
 signal(SIGUSR1,arrivo);
 read(fdarrivi[0],buf,1);
 sscanf(buf,"%d",&numtreno);
 LE[numtreno]=1;
 printf("Arrivo al binario %d\n",numtreno);
}


void treno(int ntren)
{
 numerotreno=ntren;		
 
 signal(SIGUSR1,dovevado);
 signal(SIGUSR2,vadovia);
 close(fdarrivi[0]); /*Il treno scrive solo */
 close(fdpartenze[0]);
 printf("Treno %d creato\n",numerotreno);
 
 sleep(rand()%2+K);
 
 
 /* Il treno aspetta prima di arrivare */
 
 printf("Il treno %d segnala di essere arrivato",numerotreno); 
 kill(SIGUSR1,getppid()); /* Segnala di essere arrivato */
 pause(); /* Aspetta per entrare in stazione */
 sleep(rand()%10); /* Aspetta sul suo binario di uscita */
 kill(SIGUSR2,getppid());
 printf("Treno:%d Ciao ciao!!",ntren); 
 
 
}

void dovevado(int sig)
{
 char lu[2]=" ";
 signal(SIGUSR1,dovevado);

 
 sprintf(lu,"%d",rand()%4);
 write(fdarrivi[1],lu,1);
}

void vadovia(int sig)
{
  char s[2]=" ";
		
  signal(SIGUSR2,vadovia);
  sleep(rand()%10);
  kill(SIGUSR2,getppid());
  
  sprintf(s,"%d",numerotreno);
  write(fdpartenze[1],s,(size_t) 1);
}
  
void niente(int sig)
{
	signal(SIGALRM,niente);
}	
  		 
 
